/*
 * $Id: tokenizer.h,v 1.2 2008/10/22 10:12:41 hschaa Exp $
 *
 *
 * Project     :  SCPM (System Configuration Profile Management)
 * Module      :  Tokenizer
 * File        :  tokenizer.h
 * Description :  Helper class to tokenize strings
 * Author      :  Joachim Gleissner <jg@suse.de>
 *
 * Copyright 2002 SuSE Linux AG
 *
 * Released under the terms of the GNU General Public License
 * (see file COPYRIGHT in project root directory).
 *
 */
#ifndef TOKENIZER_H
#define TOKENIZER_H

#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif

#include <cstdlib>
#include <cstring>
#include <string>

class Tokenizer
{
public:
  struct end_of_tokens{};
  Tokenizer( const char *str, const char *delim=" " ) { s = strdup(str); d=delim; i=0; };
  ~Tokenizer() { free( s ); };
  std::string &GetToken() throw( end_of_tokens ) {
    static std::string tok;
    tok="";
    while ( is_in( s[i], d) ) i++;
    if ( s[i] == '\0' ) throw end_of_tokens();
    while ( (s[i]!='\0') && (!is_in( s[i], d ) ) ) tok+=s[i++];
    return tok;
  };
    
private:
  char *s;
  const char *d;
  unsigned int i;
  bool is_in( char c, const char *s ) {
    for (unsigned int i=0; i<std::strlen(s); i++)
      if ( c == s[i] ) return true;
    return false;
  };
};

#endif
