/*
 * $Id: globals.h,v 1.1.1.1 2005/05/11 09:03:12 gleissner Exp $
 *
 *
 * Project     :  SCPM (System Configuration Profile Management)
 * Module      :  SCPM command line interface
 * File        :  globals.h
 * Description :  global variables and definitions
 * Author      :  Joachim Gleissner <jg@suse.de>
 *
 * Copyright 2002-2004 SuSE Linux AG
 *
 * Released under the terms of the GNU General Public License
 * (see file COPYRIGHT in project root directory).
 *
 */
#ifndef GLOBALS_H
#define GLOBALS_H

#include <scpm.h>
#include <scpm_types.h>
#include <scdb.h>
#include <scdb_util.h>
#include <string>

static int err_no;
extern SCPM *scpm;
extern SCDB *db;
extern SCDBUtil *util;

const int CMD_INIT         =  1;
const int CMD_ENABLE       =  2;
const int CMD_DISABLE      =  3;
const int CMD_ACTIVE       =  4;
const int CMD_LIST         =  5;
const int CMD_ADD          =  6;
const int CMD_COPY         =  7;
const int CMD_DELETE       =  8;
const int CMD_RENAME       =  9;
const int CMD_RELOAD       = 10;
const int CMD_SWITCH       = 11;
const int CMD_MODIFY       = 12;
const int CMD_SET          = 13;
const int CMD_GET          = 14;
const int CMD_STATUS       = 15;
const int CMD_SAVE         = 16;
const int CMD_DIFF         = 17;
const int CMD_LIST_GROUPS  = 18;
const int CMD_ACT_GROUP    = 19;
const int CMD_DEACT_GROUP  = 20;
const int CMD_REBUILD      = 21;
const int CMD_SHOW_GROUP   = 22;
const int CMD_REMOVE_GROUP = 23;
const int CMD_RESET_GROUP  = 24;
const int CMD_RESET_ALL    = 25;
const int CMD_UPDATE_SCRIPT= 26;
const int CMD_UPDATE_RESOURCES=27;
const int CMD_BACKUP       = 28;
const int CMD_RECOVER      = 90;
const int CMD_DB           = 30;
const int  DB_NOOP         = 30;
const int  DB_HELP         = 31;
const int  DB_EXIT         = 32;
const int  DB_LOAD         = 34;
const int  DB_SAVE         = 35;
const int  DB_INFO         = 36;
const int  DB_DB_VERSION   = 37;
const int  DB_SCPM_VERSION = 38;
const int  DB_QUIT         = 39;
const int  DB_CREATE       = 40;
const int  DB_DROP         = 41;
const int  DB_SHOW         = 42;
const int  DB_MINIMIZE     = 43;
const int  DB_MAXIMIZE     = 44;
const int  DB_CUSTOMIZE    = 45;
const int  DB_REBUILD_DEPS = 46;
const int  DB_CONVERT      = 47;
const int  DB_CLEAN        = 48;
const int  DB_DUMP         = 50;
const int  DB_GET          = 51;
const int  DB_SET          = 52;
const int  DB_EXPORT       = 53;
const int  DB_IMPORT       = 54;
const int  DB_UNKNOWN      = 99;

const int ERR_UNSPEC     =  1;
const int ERR_USER       = 10;
const int ERR_USERABORT  = 11;
const int ERR_SYSTEM     = 20;
const int ERR_SUBSYS     = 30;

#endif
