/*
 * $Id: executor.hh,v 1.1.1.1 2005/05/11 09:03:12 gleissner Exp $
 *
 *
 * Project		 :	SCPM (System Configuration Profile Management)
 * Module			 :	SCPM executor
 * File				 :	scpm.cc
 * Description :	executes external binaries
 * Author			 :	Joachim Gleissner <jg@suse.de>
 *
 * Copyright 2001 SuSE GmbH
 *					 2004 SuSE Linux AG
 *
 * Released under the terms of the GNU General Public License
 * (see file COPYRIGHT in project root directory).
 *
 */
#ifndef EXECUTOR_H
#define EXECUTOR_H

#include <string>
#include <vector>
#include <iostream>

class Executor
{
public:

	struct exec_failed {};

	Executor( std::string filename );
	~Executor( );

		//int Run( streambuf *outbuf, streambuf *inbuf ) throw( exec_failed );
		//int Run( vector<std::string> &out_std::strings, iostream &command_errstream ) throw( exec_failed );
	int Run( std::vector<std::string> &out_strings, std::vector<std::string> &err_strings ) throw( exec_failed );
	int Run( std::string &logdir, bool verbose=true ) throw( exec_failed );

private:

	std::string fname;
	char *args[20];
	int num_args;

};

class Script
{
public:

	Script( const std::string &filename );

	void Exec();

private:

	const std::string &scriptfile;

};


#endif


