/*
 * $Id: modlib.hh,v 1.1.1.1 2005/05/11 09:03:12 gleissner Exp $
 *
 *
 * Project		 :	SCPM (System Configuration Profile Management)
 * Module			 :	Module library
 * File				 :	modlib.hh
 * Description :	support functions for resource type modules
 * Author			 :	Joachim Gleissner <jg@suse.de>
 *
 * Copyright 2001 SuSE GmbH
 *
 * Released under the terms of the GNU General Public License
 * (see file COPYRIGHT in project root directory).
 *
 */
#ifndef MODLIB_H
#define MODLIB_H

#include <string>
#include <vector>
#include <iostream>

class Modlib
{
public:

	struct handler_not_available {};
	
	std::string GetMD5sum( std::string filename );
	std::string GetMD5sum( std::istream &input );

	int CallHandler( std::string resource_type, std::string resource_name,
									 std::string action, std::string args,
									 std::vector<std::string> &output,
									 std::vector<std::string> &errout )
		throw( handler_not_available );
	bool HasHandler( std::string resource_type, std::string resource_name, std::string action );

};

#endif
