/*
 * $Id: progress.hh,v 1.1.1.1 2005/05/11 09:03:12 gleissner Exp $
 *
 *
 * Project		 :	SCPM (System Configuration Profile Management)
 * Module			 :	SCPM main engine
 * File				 :	progress.hh
 * Description :	helper class for progress visualization
 * Author			 :	Joachim Gleissner <jg@suse.de>
 *
 * Copyright 2001 SuSE GmbH
 *					 2002,2003 SuSE Linux AG
 *
 * Released under the terms of the GNU General Public License
 * (see file COPYRIGHT in project root directory).
 *
 */
#ifndef PROGRESS_H
#define PROGRESS_H

#include <iostream>
#include <string>

class Progress
{
public:

	static const int verbose		= 1;
	static const int hash_marks = 2;
	static const int quiet			= 4;
	
	friend class SCPM;

	static Progress *GetHandle( ) { return progress; };

	void SetOutputMode( int flags );
	void SetBar( int bar_length=100 );
	void Print( const std::string &info, int verbose=0 );
	void Newline( int verbose=0 );
	void SetSegment( int percent );
	void SetSegmentSteps( int steps );
	void BarStep( );
	void ResetBar( );

private:

	Progress( std::ostream &info_out, std::ostream &hash_out );
	~Progress( );

	static Progress *progress;

	std::ostream &output_info;
	std::ostream &output_hash;
	int vlev;
	int output_flags;
	int abs_length;
	int abs_actual;
	int abs_printed;
	int seg_length;
	int seg_percent;
	int seg_actual;
	int seg_printed;
	bool new_bar;
};

#endif
