/*
 * $Id: resource_helpers.hh,v 1.1.1.1 2005/05/11 09:03:12 gleissner Exp $
 *
 *
 * Project		 :	SCPM (System Configuration Profile Management)
 * Module			 :	SCPM main engine
 * File				 :	resource_helpers.hh
 * Description :	defines resource specific helper routines
 * Author			 :	Joachim Gleissner <jg@suse.de>
 *
 * Copyright 2001 SuSE GmbH
 *					 2002 SuSE Linux AG
 *
 * Released under the terms of the GNU General Public License
 * (see file COPYRIGHT in project root directory).
 *
 */
#ifndef RESOURCE_HELPERS_H
#define RESOURCE_HELPERS_H

#include <resource.hh>
#include <vector>
#include <scdb.hh>
#include <log.hh>

// add resource type headers here
#include <file.hh>
#include <service.hh>
#include <sysconfig.hh>

class Resource_helpers
{
public:

	struct type_invalid {};

	Resource_helpers( ) { 
		module_names.push_back( "file" );
			//module_names.push_back( "sysconfig" );
		module_names.push_back( "service" );
			// add resource module names here
	};
	~Resource_helpers( );

	std::vector<std::string> GetResourceTypes( ) { return module_names; };
	std::vector<std::string> GetResourceNames( std::string resource_type );
	Resource *CreateObject( std::string resource_type, std::string resource_name, bool allow_missing=false )
		throw ( type_invalid, Resource::resource_unknown );
 
private:

	Log *log;

	std::vector<std::string> module_names;
	
};


#endif

